'use strict';

function _interopDefault (ex) { return (ex && (typeof ex === 'object') && 'default' in ex) ? ex['default'] : ex; }

var React = _interopDefault(require('react'));

/*! *****************************************************************************
Copyright (c) Microsoft Corporation. All rights reserved.
Licensed under the Apache License, Version 2.0 (the "License"); you may not use
this file except in compliance with the License. You may obtain a copy of the
License at http://www.apache.org/licenses/LICENSE-2.0

THIS CODE IS PROVIDED ON AN *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED
WARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE,
MERCHANTABLITY OR NON-INFRINGEMENT.

See the Apache Version 2.0 License for specific language governing permissions
and limitations under the License.
***************************************************************************** */

var __assign = function() {
    __assign = Object.assign || function __assign(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};

function __rest(s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
}

var actions = [
    {
        id: 'equals',
        name: 'Equals',
        action: function (value1, value2) {
            return value1 === value2;
        },
    },
    {
        id: 'greater',
        name: 'Greater than',
        action: function (value1, value2) {
            return value1 > value2;
        }
    },
    {
        id: 'less',
        name: 'Less than',
        action: function (value1, value2) {
            return value1 < value2;
        }
    },
    {
        id: 'contains',
        name: 'Contains',
        action: function (value1, value2) {
            return value1.includes(value2);
        }
    },
];
var available = actions.map(function (action) { return action.id; });

var Main = function (_a) {
    var showInput = _a.showInput, showOutput = _a.showOutput, handleChangeValue1 = _a.handleChangeValue1, handleChangeMode = _a.handleChangeMode, handleChangeValue2 = _a.handleChangeValue2, initialValue1 = _a.initialValue1, initialMode = _a.initialMode, initialValue2 = _a.initialValue2, Select = _a.Select, Option = _a.Option, Input = _a.Input;
    // @ts-ignore
    handleChangeMode({ 'target': { 'value': initialMode } });
    return (React.createElement(React.Fragment, null,
        showInput &&
            React.createElement(Input, { label: 'Value', value: initialValue1, onKeyUp: handleChangeValue1 }),
        React.createElement(Select, { onChange: handleChangeMode }, actions.map(function (action) {
            return (React.createElement(Option, { key: action.id, selected: action.id === initialMode, name: action.name, value: action.id }));
        })),
        showOutput &&
            React.createElement(Input, { label: 'Value', value: initialValue2, onKeyUp: handleChangeValue2 })));
};
var Input = function (_a) {
    var id = _a.id, label = _a.label, rest = __rest(_a, ["id", "label"]);
    return (React.createElement(React.Fragment, null,
        React.createElement("label", { htmlFor: id }, label),
        React.createElement("input", __assign({ type: 'text' }, rest))));
};
var handleChange = function (event) {
    console.warn('You need to implement this. Changed value:', event.target.value);
};
Main.defaultProps = {
    showInput: true,
    showOutput: true,
    initialMode: 'equals',
    handleChangeValue1: handleChange,
    handleChangeMode: handleChange,
    handleChangeValue2: handleChange,
    Input: Input,
};

var Select = function (props) {
    return (React.createElement("select", __assign({}, props), props.children));
};
var Option = function (_a) {
    var name = _a.name, value = _a.value;
    return React.createElement("option", { value: value }, name);
};
var Main$1 = function (props) {
    return (React.createElement(Main, __assign({}, props, { Select: Select, Option: Option })));
};

module.exports = Main$1;
